using JetBrains.Annotations;
using UnityEngine;

namespace Magify
{
    public class EditorDevice
    {
        public RuntimePlatform Platform { get; init; }

        [CanBeNull]
        public string DeviceName { get; init; }

        [CanBeNull]
        public string DeviceVersion { get; init; }

        [CanBeNull]
        public Orientation? SupportedOrientation { get; init; }

        [CanBeNull]
        public bool? IsTablet { get; init; }

        [CanBeNull]
        public string Idfa { get; init; }

        [CanBeNull]
        public string Idfv { get; init; }

        [CanBeNull]
        public string GpsAdId { get; init; }

        public static EditorDevice GetDefaultAndroidDevice() => new()
        {
            Platform = RuntimePlatform.Android,
            DeviceName = "phone-xhdpi",
            DeviceVersion = "30",
            SupportedOrientation = Orientation.Portrait,
            IsTablet = false,
        };

        public static EditorDevice GetDefaultIOSDevice() => new()
        {
            Platform = RuntimePlatform.IPhonePlayer,
            DeviceName = "iPhone10,4",
            DeviceVersion = "16.6.1",
            SupportedOrientation = Orientation.Portrait,
            IsTablet = false,
        };
    }
}