﻿using NUnit.Framework;

namespace Magify.Tests
{
    internal partial class MagifyClientTests
    {
        public class Dispose
        {
            [SetUp]
            [TearDown]
            public void ClearAllData()
            {
                EditorModeTestsEnvironment.Clear();
            }

            [Test]
            [UnitTestTarget(typeof(MagifyClient), nameof(MagifyClient.Dispose))]
            public void Create_Dispose_Recreate()
            {
                using (new MagifyClient(AppName, ConfigPath, EditorModeTestsEnvironment.RootStoragePath, OfflineEnvironment))
                {
                }
                using (new MagifyClient(AppName, ConfigPath, EditorModeTestsEnvironment.RootStoragePath, OfflineEnvironment))
                {
                }
            }

            [Test]
            public void Create_Initialize_Dispose_Recreate()
            {
                using (var client = new MagifyClient(AppName, ConfigPath, EditorModeTestsEnvironment.RootStoragePath, OfflineEnvironment))
                {
                    client.InitializeSdk();
                }
                using (new MagifyClient(AppName, ConfigPath, EditorModeTestsEnvironment.RootStoragePath, OfflineEnvironment))
                {
                }
            }

            [Test]
            public void Create_Initialize_Dispose_Recreate_Initialize()
            {
                using (var client = new MagifyClient(AppName, ConfigPath, EditorModeTestsEnvironment.RootStoragePath, OfflineEnvironment))
                {
                    client.InitializeSdk();
                }
                using (var client = new MagifyClient(AppName, ConfigPath, EditorModeTestsEnvironment.RootStoragePath, OfflineEnvironment))
                {
                    client.InitializeSdk();
                }
            }

            [Test]
            public void Create_InitializeSetup_Dispose_Recreate()
            {
                using (var client = new MagifyClient(AppName, ConfigPath, EditorModeTestsEnvironment.RootStoragePath, OfflineEnvironment))
                {
                    client.InitializeSdk();
                    client.Setup();
                }
                using (new MagifyClient(AppName, ConfigPath, EditorModeTestsEnvironment.RootStoragePath, OfflineEnvironment))
                {
                }
            }

            [Test]
            public void Create_InitializeSetup_Dispose_Recreate_InitializeSetup()
            {
                using (var client = new MagifyClient(AppName, ConfigPath, EditorModeTestsEnvironment.RootStoragePath, OfflineEnvironment))
                {
                    client.InitializeSdk();
                    client.Setup();
                }
                using (var client = new MagifyClient(AppName, ConfigPath, EditorModeTestsEnvironment.RootStoragePath, OfflineEnvironment))
                {
                    client.InitializeSdk();
                    client.Setup();
                }
            }

            [Test]
            public void Create_InitializeSetup_Dispose_ClearAllData_Recreate_InitializeSetup()
            {
                using (var client = new MagifyClient(AppName, ConfigPath, EditorModeTestsEnvironment.RootStoragePath, OfflineEnvironment))
                {
                    client.InitializeSdk();
                    client.Setup();
                }
                EditorModeTestsEnvironment.Clear();
                using (var client = new MagifyClient(AppName, ConfigPath, EditorModeTestsEnvironment.RootStoragePath, OfflineEnvironment))
                {
                    client.InitializeSdk();
                    client.Setup();
                }
            }
        }
    }
}